"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _semverCompare = _interopRequireDefault(require("semver-compare"));

var _package = require("../../package.json");

var _config = require("../config");

var _createWriter = _interopRequireDefault(require("./createWriter"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// eslint-disable-next-line flowtype/no-weak-types
var _default = currentState => {
  const versions = (currentState.versions || []).concat();
  versions.sort(_semverCompare.default);
  const currentIsLatestVersion = !versions.length || (0, _semverCompare.default)(_package.version, versions[versions.length - 1]) === 1;

  if (!versions.includes(_package.version)) {
    versions.push(_package.version);
  }

  versions.sort(_semverCompare.default);
  const newState = {
    buffer: '',
    prepend: {},
    sequence: 0,
    ...currentState,
    versions
  };

  if (currentIsLatestVersion || !newState.write) {
    const Writer = (0, _createWriter.default)({
      bufferSize: _config.ROARR_BUFFER_SIZE,
      stream: _config.ROARR_STREAM
    });
    newState.write = Writer.write;
    newState.flush = Writer.flush;
  }

  return newState;
};

exports.default = _default;
//# sourceMappingURL=createRoarrInititialGlobalState.js.map