"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

// @todo Add browser support.
var _default = configuration => {
  const stream = configuration.stream.toUpperCase() === 'STDOUT' ? process.stdout : process.stderr;

  if (!configuration.bufferSize) {
    return {
      flush: () => {},
      write: message => {
        stream.write(message + '\n');
      }
    };
  }

  const flush = () => {
    if (!global.ROARR.buffer) {
      return;
    }

    const buffer = global.ROARR.buffer;
    global.ROARR.buffer = '';
    stream.write(buffer);
  };

  return {
    flush,
    write: message => {
      global.ROARR.buffer += message + '\n';

      if (global.ROARR.buffer.length > configuration.bufferSize) {
        flush();
      } // @todo Write messages when the event loop is not busy.

    }
  };
};

exports.default = _default;
//# sourceMappingURL=createWriter.js.map