"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _factories = require("./factories");

var _config = require("./config");

global.ROARR = (0, _factories.createRoarrInititialGlobalState)(global.ROARR || {}); // We want to register just one event listener for 'exit' event
// across all instances of Roarr.

if (!global.ROARR.registeredFlush) {
  global.ROARR.registeredFlush = true;
  process.on('exit', () => {
    if (global.ROARR.flush) {
      global.ROARR.flush();
    }
  });
}

var _default = (0, _factories.createLogger)(message => {
  if (!_config.ROARR_LOG) {
    return;
  }

  const body = JSON.stringify(message);
  global.ROARR.write(body);
});

exports.default = _default;
//# sourceMappingURL=log.js.map